/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	MDX loader(interface)
	mdx.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Project headers */
#include "lzx042.h"
#include "mdx.h"
#include "pdx.h"
#include "uty.h"

static char tempmdx[MAX_PATH] = "";

void CleanMDX(void)
{
	if (tempmdx[0] != '\0')
	{
		DeleteFile(tempmdx);
		tempmdx[0] = '\0';
	}
	CleanPDX();
}

char *LoadMDX(char *infile, char *pdxpath)
{
	char *mdxbuf = NULL, *lzxbuf = NULL;
	char *ret = infile;
	CleanMDX();
	do
	{
		HANDLE hTemp = INVALID_HANDLE_VALUE;
		char temppath[MAX_PATH];
		char title[MAX_PATH], pdxname[MAX_PATH], *sp, *dp;
		DWORD mdxsize, lzxsize;
		int i, tlen, plen, datasize;

		sp = mdxbuf = LoadFile(infile, &mdxsize);
		if (mdxbuf == NULL) break;

		for (dp = title; *sp != '\x1a';) *(dp++) = *(sp++);	/* title */
		*(dp++) = '\0';	sp++;
		for (dp = pdxname; *sp != '\0';) *(dp++) = *(sp++);	/* pdxname */
		*(dp++) = '\0';	sp++;
		datasize = mdxsize - (sp - mdxbuf);
		lzxsize = IsLzxEncoded(sp);

		if (LoadPDX(infile, pdxpath, pdxname) == 0 && lzxsize == 0) break;

		tlen = lstrlen(title);
		plen = lstrlen(pdxname);

		if (lzxsize != 0) datasize = lzxsize;
		dp = lzxbuf = malloc(tlen + 1 + plen + 1 + datasize);
		if (lzxbuf == NULL) break;

		lstrcpy(dp, title);		dp[tlen] = '\x1a';	dp += tlen + 1; 
		lstrcpy(dp, pdxname);	dp[plen] = '\0';	dp += plen + 1; 

		if (lzxsize != 0)
			lzx042(sp, dp);
		else
			CopyMemory(dp, sp, datasize);
		dp += datasize;

		GetTempPath(MAX_PATH, temppath);
		for (i = 1; hTemp == INVALID_HANDLE_VALUE; i++)
		{
			wsprintf(tempmdx, "%stmp_%d.mdx",temppath, i);
			hTemp = CreateFile(
				tempmdx,
				GENERIC_READ | GENERIC_WRITE,
				FILE_SHARE_READ | FILE_SHARE_WRITE/* | FILE_SHARE_DELETE*/,
				NULL,
				CREATE_NEW,
				FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_DELETE_ON_CLOSE*/,
				NULL
			);
		}
		if (hTemp != INVALID_HANDLE_VALUE)
		{
			WriteFile(hTemp, lzxbuf, dp - lzxbuf, &mdxsize, NULL);
			CloseHandle(hTemp);
			ret = tempmdx;
		}
		else
		{
			tempmdx[0] = '\0';
		}
	} while(0);

	freefile(mdxbuf);
	freefile(lzxbuf);
	if (ret == infile) CleanMDX();
	return ret;
}

void GetTitleMDX(char *fn, char *title)
{
	HANDLE hFile = CreateFile(
		fn,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD i, len = 0;
		char buf[128], *p;
		if (ReadFile(hFile, buf, sizeof(buf), &len, NULL))
		{
			for (p = title, i = 0; i < len; i++)
			{
				if (buf[i] == '\x1a' || buf[i] == '\x00') break;
				if (buf[i] == '\x0d' || buf[i] == '\x0a') continue;
				*(p++) = buf[i];
			}
			*p = '\0';
		}
		CloseHandle(hFile);
	}
}
