/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	PDX loader
	pdx.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Project headers */
#include "pdx.h"
#include "lzx042.h"
#include "uty.h"

static char temppdx[MAX_PATH] = "";
void CleanPDX(void)
{
	if (temppdx[0] != '\0')
	{
		DeleteFile(temppdx);
		temppdx[0] = '\0';
	}
}

static void GetPathOnly(char *dp, char *sp)
{
	char *ep = NULL;
	while (*sp != '\0')
	{
		switch (*sp)
		{
			case ':':
			case '/':
			case '\\':
				ep = dp + 1;
				break;
		}
		*(dp++) = *(sp++);
	}
	if (ep != NULL) *ep = '\0';
}

static char *LoadPDXsub(char *mdxpath, char *pdxpath, char *pdxname, int *ppdxsize)
{
	int i;
	char *pdxbuf = NULL;
	char temppath[MAX_PATH];
	/* ܂MDXƓꏊ */
	GetPathOnly(pdxpath, mdxpath);
	if (pdxpath[0] != '\0')
	{
		lstrcpy(temppath, pdxpath);
		lstrcat(temppath, pdxname);
		pdxbuf = LoadFile(temppath, ppdxsize);
		if (pdxbuf != NULL) return pdxbuf;
		lstrcpy(temppath, pdxpath);
		lstrcat(temppath, pdxname);
		lstrcat(temppath, ".PDX");
		pdxbuf = LoadFile(temppath, ppdxsize);
		if (pdxbuf != NULL) return pdxbuf;
	}
	/* ͌pX */
	for (i = 0; i < MAX_PDXPATH; i++)
	{
		if (pdxpathes[i][0] == '\0') continue;
		lstrcpy(pdxpath, pdxpathes[i]);
		lstrcpy(temppath, pdxpath);
		lstrcat(temppath, pdxname);
		pdxbuf = LoadFile(temppath, ppdxsize);
		if (pdxbuf != NULL) return pdxbuf;
		lstrcpy(temppath, pdxpath);
		lstrcat(temppath, pdxname);
		lstrcat(temppath, ".PDX");
		pdxbuf = LoadFile(temppath, ppdxsize);
		if (pdxbuf != NULL) return pdxbuf;
	}
	/* ŌɃJg */
	pdxpath[0] = '\0';
	lstrcpy(temppath, pdxpath);
	lstrcat(temppath, pdxname);
	pdxbuf = LoadFile(temppath, ppdxsize);
	if (pdxbuf != NULL) return pdxbuf;
	lstrcpy(temppath, pdxpath);
	lstrcat(temppath, pdxname);
	lstrcat(temppath, ".PDX");
	pdxbuf = LoadFile(temppath, ppdxsize);
	if (pdxbuf != NULL) return pdxbuf;
	return NULL;
}

int LoadPDX(char *mdxpath, char *pdxpath, char *pdxname)
{
	int ret = 0;
	char *pdxbuf = NULL, *lzxbuf = NULL;
	if (pdxname[0] == '\0') return ret;
	CleanPDX();
	do
	{
		int i;
		HANDLE hTemp = INVALID_HANDLE_VALUE;
		char temppath[MAX_PATH];
		DWORD pdxsize, lzxsize;
		pdxbuf = LoadPDXsub(mdxpath, pdxpath, pdxname, &pdxsize);
		if (pdxbuf == NULL) break;
		lzxsize = IsLzxEncoded(pdxbuf);
		if (!lzxsize) break;	/* k */

		/* kPDX */
		lzxbuf = malloc(lzxsize);
		if (lzxbuf == NULL) break;
		lzx042(pdxbuf, lzxbuf);

		GetTempPath(MAX_PATH, temppath);
		lstrcpy(pdxpath, temppath);	/* e|ɏo */
		for (i = 1; hTemp == INVALID_HANDLE_VALUE; i++)
		{
			wsprintf(temppdx, "%stmp_%d.pdx",temppath, i);
			hTemp = CreateFile(
				temppdx,
				GENERIC_READ | GENERIC_WRITE,
				FILE_SHARE_READ | FILE_SHARE_WRITE/* | FILE_SHARE_DELETE*/,
				NULL,
				CREATE_NEW,
				FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_DELETE_ON_CLOSE*/,
				NULL
			);
		}
		if (hTemp != INVALID_HANDLE_VALUE)
		{
			if (lzxsize)
				WriteFile(hTemp, lzxbuf, lzxsize, &pdxsize, NULL);
			else
				WriteFile(hTemp, pdxbuf, pdxsize, &lzxsize, NULL);
			CloseHandle(hTemp);
			lstrcpy(pdxname, temppdx + lstrlen(temppath));
			ret = 1;
		}
		else
		{
			temppdx[0] = '\0';
			pdxpath[0] = '\0';
		}
	} while (0);
	freefile(pdxbuf);
	freefile(lzxbuf);
	if (ret == 0) CleanPDX();
	return ret;
}
