/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	MDX sequencer(MDXDRV interface)
	seq_mdx.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>
#include <shlobj.h>

/* Libraries headers */
#include "memmap_m.h"

/* Project headers */
#include "../sequencer.h"
#include "mdx.h"
#include "mdc.h"
#include "pdx.h"
#include "spc.h"
#include "log.h"
#include "uty.h"

#define MAX_FILETYPES 32
#define MAX_TYP 128
#define MAX_EXT 128
#define MAX_OPT 256
#define MDXDRV_CMDLINE (MAX_PATH + MAX_OPT + MAX_PATH + 32)

enum MDC_STATE {
	MDC_OPEN,
	MDC_CLOSE
};

typedef struct {
	HANDLE hMap;
	volatile MdxdrvStatus *status;
	char cmdLine[MDXDRV_CMDLINE];
	LONG lock;
	unsigned int BootTime;
	enum MDC_STATE state;
	signed char id;
	int bufp;
} MDXDRVCONTROL;

static void MDCInit(MDXDRVCONTROL *pmdc)
{
	pmdc->state = MDC_CLOSE;
	pmdc->hMap = NULL;
	pmdc->status = NULL;
	pmdc->id = '\xff';
	pmdc->lock = 1;
}

static void MDCFreeControl(MDXDRVCONTROL *pmdc)
{
	if (pmdc->state != MDC_OPEN) return;
	if (pmdc->BootTime == pmdc->status->BootTime)
	{
		pmdc->status->ID[pmdc->id] = 0;
		InterlockedDecrement((LPLONG)&pmdc->status->InterLock);
	}
	UnmapViewOfFile((LPVOID)pmdc->status);	/* YƃRꂷ */
	CloseHandle(pmdc->hMap);
	pmdc->state = MDC_CLOSE;
	InterlockedExchange(&pmdc->lock, 1);	/* 䌠ԋp */
}

static BOOL MDCBootMDXDRV(MDXDRVCONTROL *pmdc)
{
	static STARTUPINFO si;
	static PROCESS_INFORMATION pi;
	char cwd[MAX_PATH];
	ZeroMemory(&si, sizeof(STARTUPINFO));
	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	si.cb = sizeof(STARTUPINFO);
	si.lpReserved = NULL;
	si.lpDesktop = NULL;
	si.lpTitle = NULL;
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = /*SW_SHOWDEFAULT*/SW_HIDE;
	si.cbReserved2 = 0;
	si.lpReserved2 = NULL;
	GetCurrentDirectory(MAX_PATH, cwd);
	if (CreateProcess(NULL, pmdc->cmdLine,
		NULL, NULL, FALSE,
		NORMAL_PRIORITY_CLASS,
		NULL,
		cwd,
		&si,
		&pi))
	{
		/* Ȃ͎̂̂Ă */
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
		return TRUE;
	}
	return FALSE;
}

static BOOL MDCGetControl(MDXDRVCONTROL *pmdc, BOOL bBoot)
{
	int time_out = -1;
	/* 䌠擾 */
	if (1 != InterlockedExchange(&pmdc->lock, 0)) return FALSE;
	do
	{
		if (time_out > 0)
		{
			Sleep(10);
			time_out -= 10;
		}
		/* ċNMDXDRVɋNĂ邩𒲂ׂ */
		if (bBoot)
		{
			HANDLE hMutex;
			hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, MutexObjName);
			if (hMutex != NULL)
			{
				CloseHandle(hMutex);
			}
			else
			{
				/* ċÑ`X͈x */
				bBoot = FALSE;
				/* NĂȂ΋N */
				if (MDCBootMDXDRV(pmdc))
				{
					/* Ƃ肠 500ms ҂ */
					Sleep(500);
					/*  500ms e */
					time_out = 500;
				}
			}
		}
		/* L̃I[v */
		pmdc->hMap = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, MapObjName);
		if (pmdc->hMap == NULL)
		{
			/* sɍċNĂ΋N */
			if (bBoot)
			{
				/* ċÑ`X͈x */
				bBoot = FALSE;
				if (MDCBootMDXDRV(pmdc))
				{
					/* ċNɐĂђ */
					/* ł̑OɁEEE */
					/* Ƃ肠 500ms ҂ */
					Sleep(500);
					/*  500ms e */
					time_out = 500;
				}
				else
				{
					/* NɎsꍇ */
					InterlockedExchange(&pmdc->lock, 1);	/* 䌠ԋp */
					return FALSE;
				}
			}
			continue;
		}
		pmdc->status = (MdxdrvStatus *)MapViewOfFile(pmdc->hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if (pmdc->status == NULL)
		{
			CloseHandle(pmdc->hMap);
			/* N(time_out>0)Ȃ҂ */
			continue;
		}
		/* L̏݌ */
		time_out = 500;
		while (time_out > 0)
		{
			pmdc->BootTime = pmdc->status->BootTime;	/* NҔ */
			/* if (pmdc->BootTime != 0) */
			{
				if (InterlockedIncrement((LPLONG)&pmdc->status->InterLock) == 0)
				{
					for (pmdc->id = 8; pmdc->id < memIDmax; pmdc->id++)
					{
						if (pmdc->status->ID[pmdc->id] != 0) continue;
						/* ID擾 */
						pmdc->status->ID[pmdc->id] = pmdc->id;
						/* 䌠ێ */
						pmdc->state = MDC_OPEN;
						return TRUE;
					}
					if (pmdc->BootTime == pmdc->status->BootTime)
						InterlockedDecrement((LPLONG)&pmdc->status->InterLock);
					UnmapViewOfFile((LPVOID)pmdc->status);
					CloseHandle(pmdc->hMap);
					InterlockedExchange(&pmdc->lock, 1);	/* 䌠ԋp */
					/* ID̋󂫂Ȃ */
					return FALSE;
				}
				if (pmdc->BootTime == pmdc->status->BootTime)
					InterlockedDecrement((LPLONG)&pmdc->status->InterLock);
			}
			Sleep(10);
			time_out -= 10;
		}
		UnmapViewOfFile((LPVOID)pmdc->status);
		CloseHandle(pmdc->hMap);
		InterlockedExchange(&pmdc->lock, 1);	/* 䌠ԋp */
		/* ݌擾łȂ */
		return FALSE;
	} while (time_out > 0);
	InterlockedExchange(&pmdc->lock, 1);	/* 䌠ԋp */
	/* I[vłȂ */
	return FALSE;
}

static BOOL MDCWait(MDXDRVCONTROL *pmdc, int load)
{
	int time_out = 500;
	if (pmdc->state != MDC_OPEN) return FALSE;
	while (pmdc->status->load != load)
	{
#if 0
		/* drvopt`FbN */
		char buf[256];
		wsprintf(buf, "L:%d ", pmdc->status->load);
		OutputDebugString(buf);
#endif
		if (time_out < 0) return FALSE;
		Sleep(10);
		time_out -= 10;
	}
	pmdc->bufp = 0;
	return TRUE;
}

static BOOL MDCWaitInfinite(MDXDRVCONTROL *pmdc, int load)
{
	if (pmdc->state != MDC_OPEN) return FALSE;
	while (pmdc->status->load != load)
	{
		HANDLE hMutex;
		Sleep(10);
		/* }bvL`FbN */
		if (pmdc->BootTime != pmdc->status->BootTime)
			return FALSE;
		/* I`FbN */
		hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, MutexObjName);
		if (hMutex == NULL)
			return FALSE;
		CloseHandle(hMutex);
	}
	pmdc->bufp = 0;
	return TRUE;
}

static void MDCWriteDword(MDXDRVCONTROL *pmdc, DWORD dw)
{
	if (pmdc->state != MDC_OPEN) return;
	pmdc->status->buff[pmdc->bufp++] = (char)(dw >> 0x00);
	pmdc->status->buff[pmdc->bufp++] = (char)(dw >> 0x08);
	pmdc->status->buff[pmdc->bufp++] = (char)(dw >> 0x10);
	pmdc->status->buff[pmdc->bufp++] = (char)(dw >> 0x18);
}

static BOOL MDCReadDword(MDXDRVCONTROL *pmdc, int *lpdw)
{
	if (pmdc->state != MDC_OPEN) return FALSE;
	*lpdw  = ((int)(unsigned char)pmdc->status->buff[pmdc->bufp++]) << 0x00;
	*lpdw |= ((int)(unsigned char)pmdc->status->buff[pmdc->bufp++]) << 0x08;
	*lpdw |= ((int)(unsigned char)pmdc->status->buff[pmdc->bufp++]) << 0x10;
	*lpdw |= ((int)(unsigned char)pmdc->status->buff[pmdc->bufp++]) << 0x18;
	return TRUE;
}

static void MDCWriteString(MDXDRVCONTROL *pmdc, char *p)
{
	if (pmdc->state != MDC_OPEN) return;
	while (*p) pmdc->status->buff[pmdc->bufp++] = *(p++);
	pmdc->status->buff[pmdc->bufp++] = '\0';
}

/* MDX sequencer struct */
typedef struct {
	SEQUENCER seq;			/* KUMAamp common interface */
	MDXDRVCONTROL mdc;

	int isplaying;
	int volume;
	int panpot;
#if 0
	int loopc;				/* zero based loopcounter */
	int loopcount;			/* max loop count */
	int frequency;			/* mixing frequency */
	int fade;				/* 0:normal 1-:fading out(dB/(1 >> FADE_SHIFT)) */
	int fadetime;			/* fadeout time(ms) */
#endif
} MDXSEQ;
#define PTR__ ((MDXSEQ *)(this__->work))

/* amp setting struct */
static struct {
	char mdxdrvpath[MAX_PATH];
	struct {
		char typ[MAX_TYP];
		char ext[MAX_EXT];
		char opt[MAX_OPT];
	} filetypes[MAX_FILETYPES];

	int priority;

	HINSTANCE hDllInstance;
	char cfgname[MAX_PATH];
} setting;
char pdxpathes[MAX_PDXPATH][MAX_PATH];

static void Pause(SEQUENCER *this__, int ispause)
{
	if (/*PTR__->isplaying && */MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 1);	/* S̉t */
			MDCWriteDword(&PTR__->mdc, ispause ? 0 : 1);
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id);
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
}

static void SetVolumePan(SEQUENCER *this__)
{
	int lvol, rvol;
	if (MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			rvol = lvol = (100 * PTR__->volume) >> 7;
			if (PTR__->panpot > 0) lvol = (lvol * (127 - PTR__->panpot)) >> 7;
			if (PTR__->panpot < 0) rvol = (rvol * (127 + PTR__->panpot)) >> 7;
			MDCWriteDword(&PTR__->mdc, 11);	/* volume */
			MDCWriteDword(&PTR__->mdc, lvol);
			MDCWriteDword(&PTR__->mdc, rvol);
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id);
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
}
static void SetVolume(SEQUENCER *this__, int volume)
{
	PTR__->volume = volume;
	SetVolumePan(this__);
}
static void SetPan(SEQUENCER *this__, int panpot)
{
	PTR__->panpot = panpot;
	SetVolumePan(this__);
}

static void Play(SEQUENCER *this__)
{
	int retcode = 0;
	if (PTR__->isplaying == 0 && MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 3);	/* VR}hC̐ݒ */
			MDCWriteString(&PTR__->mdc, PTR__->mdc.cmdLine);
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[2 */
			PTR__->mdc.status->load = PTR__->mdc.id;
			if (MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id))
			{
				int ret;
				if (
					MDCReadDword(&PTR__->mdc, &ret) && ret == 3 &&
					MDCReadDword(&PTR__->mdc, &ret) && ret >= 4 &&
					MDCReadDword(&PTR__->mdc, &ret)
				)
				{
					if (ret == -1)
					{
						/* }bvoR̋N */
						PTR__->isplaying = 1;
					}
					else
					{
						retcode = ret;
					}
				}
			}
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
	/* Iׂ͏I */
	if (retcode && MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 5);	/* I */
			MDCWriteString(&PTR__->mdc, "");	/* ⓚp */
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id);
			PTR__->mdc.status->load = 0;
			Sleep(500);
		}
		MDCFreeControl(&PTR__->mdc);
	}
	/* }bvł܂ȂꍇċN݂ */
	if (PTR__->isplaying == 0 && MDCGetControl(&PTR__->mdc, TRUE))
	{
		PTR__->isplaying = 1;
		MDCFreeControl(&PTR__->mdc);
	}
}

static void TermMdxdrv(MDXDRVCONTROL *pmdc)
{
	MDXDRVCONTROL temp;
	if (pmdc == NULL)
	{
		MDCInit(&temp);
		pmdc = &temp;
	}
	if (MDCGetControl(pmdc, FALSE))
	{
		if (MDCWait(pmdc, 0))
		{
			MDCWriteDword(pmdc, 5);	/* I */
			MDCWriteString(pmdc, MutexObjName);
			MDCWriteDword(pmdc, 0);	/* functionI[ */
			pmdc->status->load = pmdc->id;
			MDCWaitInfinite(pmdc, -pmdc->id);
			pmdc->status->load = 0;
		}
		MDCFreeControl(pmdc);
	}
}

#define TERM_ON_STOP 0
static void Stop(SEQUENCER *this__)
{
#if TERM_ON_STOP
	TermMdxdrv(this__);
#else
	if (MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
#if 0
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			MDCWriteDword(&PTR__->mdc, 10);	/* fade out */
			MDCWriteDword(&PTR__->mdc, 1);
			MDCWriteDword(&PTR__->mdc, 1);
#endif
			MDCWriteDword(&PTR__->mdc, 1);	/* S̉t */
			MDCWriteDword(&PTR__->mdc, 2);
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id);
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
#endif
	PTR__->isplaying = 0;
}

static void Term(SEQUENCER *this__)
{
	Stop(this__);
	/* I */
	free(PTR__);
}

static void SetPosition(SEQUENCER *this__, int time_in_ms)
{
	if (/*PTR__->isplaying && */MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 4);	/* tԈʒuύX */
			MDCWriteDword(&PTR__->mdc, 1 + time_in_ms);
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id);
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
}

static int GetPosition(SEQUENCER *this__)
{
	int pos = 0;
	if (/*PTR__->isplaying && */MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 4);	/* tԈʒuύX */
			MDCWriteDword(&PTR__->mdc, 0);	/* tԈʒu߂ */
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			if (MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id))
			{
				int ret;
				if (
					MDCReadDword(&PTR__->mdc, &ret) && ret == 4 &&
					MDCReadDword(&PTR__->mdc, &ret) && ret >= 8 &&
					MDCReadDword(&PTR__->mdc, &ret) && ret == 0
				)
				{
					MDCReadDword(&PTR__->mdc, &pos);
				}
			}
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
	return pos;
}

static int GetLoopCount(SEQUENCER *this__)
{
	return 0;
}

static int IsPlaying(SEQUENCER *this__)
{
	int isplaying = 0;
	if (PTR__->isplaying && MDCGetControl(&PTR__->mdc, FALSE))
	{
		if (MDCWait(&PTR__->mdc, 0))
		{
			MDCWriteDword(&PTR__->mdc, 1);	/* S̉t */
			MDCWriteDword(&PTR__->mdc, -1);	/* Ԃ𒲂ׂ */
			MDCWriteDword(&PTR__->mdc, 0);	/* functionI[ */
			PTR__->mdc.status->load = PTR__->mdc.id;
			if (MDCWaitInfinite(&PTR__->mdc, -PTR__->mdc.id))
			{
				int ret;
				if (
					MDCReadDword(&PTR__->mdc, &ret) && ret == 1 &&
					MDCReadDword(&PTR__->mdc, &ret) && ret >= 8 &&
					MDCReadDword(&PTR__->mdc, &ret) && ret == 0 &&
					MDCReadDword(&PTR__->mdc, &ret) && (ret == 1 || ret == 0)
				)
				{
					isplaying = 1;
				}
			}
			PTR__->mdc.status->load = 0;
		}
		MDCFreeControl(&PTR__->mdc);
	}
	return isplaying;
}

static int GetPriority(SEQUENCER *this__)
{
	return setting.priority;
}

static int MakeMdxdrvComline(char *cmdLine, char *pdxpath, char *fn)
{
	int i;
	char ext[MAX_EXT];
	if (*fn == '\0') return 0;
	lstrcpy(cmdLine, setting.mdxdrvpath);
	if (*pdxpath != '\0')
	{
		lstrcat(cmdLine," /U ");
		lstrcat(cmdLine,pdxpath);
	}
	GetPathExt(ext, fn);
	for (i = 0; i < MAX_FILETYPES; i++)
	{
		if (MatchExt(ext, setting.filetypes[i].ext))
		{
			if (setting.filetypes[i].opt[0] != '\0')
			{
				lstrcat(cmdLine," ");
				lstrcat(cmdLine,setting.filetypes[i].opt);
			}
			break;
		}
	}
	lstrcat(cmdLine," \"");
	lstrcat(cmdLine,fn);
	lstrcat(cmdLine,"\"");
	return 1;
}

#ifdef SINGLE_BUILD
#define InitMdxSequencer InitSequencer
#define QuitMdxSequencer QuitSequencer
#define AboutMdxSequencer AboutSequencer
#define ConfigMdxSequencer ConfigSequencer
#define getMdxFileInfo getFileInfo
#define loadMdxFile loadFile
#define infoMdxBox infoBox
#define isOurMdxFile isOurFile
#endif

SEQUENCER *loadMdxFile(char *fn_)
{
	char ext[MAX_EXT];
	char pdxpath[MAX_PATH];
	char *fn;
	MDXSEQ *p;

	CleanPDX();
	CleanMDX();
	CleanMDC();
	CleanLOG();

	pdxpath[0] = '\0';
	p = (MDXSEQ *)malloc(sizeof(MDXSEQ));
	if (p == NULL) return NULL;

	GetPathExt(ext, fn_);
	if (MatchExt(ext, "MDX"))
	{
		fn = LoadMDX(fn_, pdxpath);
	}
	else if (MatchExt(ext, "MDC"))
	{
		fn = LoadMDC(fn_, pdxpath);
	}
	else
	{
		fn = LoadLOG(fn_);
	}

	if (!MakeMdxdrvComline(p->mdc.cmdLine, pdxpath, fn))
	{
		free(p);
		return NULL;
	}
	MDCInit(&p->mdc);
	p->isplaying = 0;
	p->volume = 128;
	p->panpot = 0;
	p->seq.work = p;
	p->seq.Play = Play;
	p->seq.Stop = Stop;
	p->seq.Pause = Pause;
	p->seq.SetVolume = SetVolume;
	p->seq.SetPan = SetPan;
	p->seq.Term = Term;
	p->seq.SetPosition = SetPosition;
	p->seq.GetPosition = GetPosition;
	p->seq.GetPriority = GetPriority;
	p->seq.GetLoopCount = GetLoopCount;
	p->seq.IsPlaying = IsPlaying;
	return &p->seq;
}

int infoMdxBox(char *fn, HWND hwndParent)
{
	HWND hwnd = FindWindow("MDX DRIVE 샋", NULL);
	PostMessage(hwnd, WM_LBUTTONDOWN, 0, 0);
	return 0;
}
int isOurMdxFile(char *fn)
{
	return 0;
}

void InitMdxSequencer(HINSTANCE hDllInstance)
{
	setting.priority = 3;
}
void QuitMdxSequencer(HINSTANCE hDllInstance)
{
#if !TERM_ON_STOP
	TermMdxdrv(NULL);
#endif
	CleanPDX();
	CleanMDX();
	CleanMDC();
	CleanLOG();
}
void AboutMdxSequencer(HWND hwndParent)
{
	MessageBox(hwndParent, "amp\n\t(C) 2000 Mamiya\n\t\tmailto:mamiya@proc.org.tohoku.ac.jp\n\t\thttp://www.proc.org.tohoku.ac.jp/befis/", PLUGIN_NAME, MB_OK);
}
void ConfigMdxSequencer(HWND hwndParent)
{
}

int getMdxFileInfo(char *fn, char *title, int *length_in_ms)
{
	char ext[MAX_EXT];
	if (title) *title = '\0';
	if (length_in_ms) *length_in_ms = 0;
	GetPathExt(ext, fn);
	if (MatchExt(ext, "MDX"))
	{
		if (title) GetTitleMDX(fn, title);
		/* if (length_in_ms) GetTimeMDX(fn, length_in_ms); */
	}
	else if (MatchExt(ext, "MDC"))
	{
		if (title) GetTitleMDC(fn, title);
		/* if (length_in_ms) GetTimeMDX(fn, length_in_ms); */
	}
	else if (MatchExt(ext, "SPC"))
	{
		if (title) GetTitleSPC(fn, title);
		if (length_in_ms) GetTimeSPC(fn, length_in_ms);
	}
	else
	{
		/* logn */
		if (title) GetTitleLOG(fn, title);
		if (length_in_ms) GetTimeLOG(fn, length_in_ms);
	}
	if (title && *title == '\0')
	{
		lstrcpy(title, "(");
		lstrcat(title, fn);
		lstrcat(title, ")");
	}
	if (length_in_ms && *length_in_ms == 0)
	{
		*length_in_ms = 5 * 60 * 1000;	/* Ƃ肠5 */
	}
	return 0;
}

static void GetSettingString(LPCSTR lpKey, LPCSTR lpDefault, LPSTR lpBuf, DWORD nSize)
{
	GetPrivateProfileString("MDXDRV", lpKey, lpDefault, lpBuf, nSize, setting.cfgname);
}
static void SetSettingString(LPCSTR lpKey, LPCSTR lpStr)
{
	WritePrivateProfileString("MDXDRV", lpKey, lpStr, setting.cfgname);
}


BOOL WINAPI DllMain(
	HINSTANCE hinstDLL,
	DWORD fdwReason,
	LPVOID lpvReserved
)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		int i, numtypes;
		char *p = FileTypes;
		char cfgbuf[MAX_PATH];
		LPSTR fnoff;
		setting.hDllInstance = hinstDLL;
		GetModuleFileName(hinstDLL, setting.cfgname, MAX_PATH);
		GetFullPathName(setting.cfgname, MAX_PATH, cfgbuf, &fnoff);
		GetPathNoExt(setting.cfgname, cfgbuf);
		lstrcat(setting.cfgname, ".ini");
		GetSettingString("MDXDRVPath","C:\\Program Files\\Winamp\\Plugins\\mdxdrv.exe /A2",setting.mdxdrvpath, MAX_PATH);
		for (numtypes = i = 0; i < MAX_FILETYPES; i++)
		{
			char key[32];
			wsprintf(key, "TYP_%d", i);
			GetSettingString(key,"",setting.filetypes[numtypes].typ, MAX_TYP);
			if (setting.filetypes[numtypes].typ[0] == '\0') continue;
			wsprintf(key, "EXT_%d", i);
			GetSettingString(key,"",setting.filetypes[numtypes].ext, MAX_EXT);
			wsprintf(key, "OPT_%d", i);
			GetSettingString(key,"",setting.filetypes[numtypes].opt, MAX_OPT);
			lstrcpy(p, setting.filetypes[numtypes].ext);
			p += lstrlen(setting.filetypes[numtypes].ext) + 1;
			lstrcpy(p, setting.filetypes[numtypes].typ);
			p += lstrlen(setting.filetypes[numtypes].typ) + 1;
			numtypes++;
		}
		if (numtypes == 0)
		{
			/* default */
			lstrcpy(setting.filetypes[numtypes].typ, "MXDRV16y music file(*.mdx)");
			lstrcpy(setting.filetypes[numtypes].ext, "MDX");
			lstrcpy(setting.filetypes[numtypes].opt, "/X");
			lstrcpy(p, setting.filetypes[numtypes].ext);
			p += lstrlen(setting.filetypes[numtypes].ext) + 1;
			lstrcpy(p, setting.filetypes[numtypes].typ);
			p += lstrlen(setting.filetypes[numtypes].typ) + 1;
			numtypes++;
		}
		for (; numtypes < MAX_FILETYPES; numtypes++)
		{
			setting.filetypes[numtypes].ext[0] = '\0';
		}
		*p = '\0';
		for (numtypes = i = 0; i < MAX_PDXPATH; i++)
		{
			char key[32], len, *p;
			wsprintf(key, "PDXPath_%d", i);
			GetSettingString(key,"",pdxpathes[numtypes], MAX_PATH);
			if (pdxpathes[numtypes][0] == '\0') continue;
			len = lstrlen(pdxpathes[numtypes]);
			p = pdxpathes[numtypes] + len - 1;
			numtypes++;
			if (len < 1) continue;
			if (*p != '\\' && *p != '/' && *p != ':')
			{
				*(++p) = '\\';
				*(++p) = '\0';
			}
		}
		for (; numtypes < MAX_PDXPATH; numtypes++)
		{
			pdxpathes[numtypes][0] = '\0';
		}
	}
	return TRUE;
}
