/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	uty.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Project headers */
#include "uty.h"

#define MAX_EXT 128

char *LoadFile(char *fn, LPDWORD lpdwSize)
{
	HANDLE hFile = INVALID_HANDLE_VALUE;
	char *ret = NULL;
	char *buf = NULL;
	do
	{
		DWORD len;
		hFile = CreateFile(
			fn,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_ARCHIVE |
			FILE_ATTRIBUTE_COMPRESSED |
			FILE_ATTRIBUTE_HIDDEN |
			FILE_ATTRIBUTE_OFFLINE |
			FILE_ATTRIBUTE_READONLY |
			FILE_ATTRIBUTE_SYSTEM |
			FILE_ATTRIBUTE_TEMPORARY |
			FILE_FLAG_SEQUENTIAL_SCAN,
			NULL);
		if (hFile == INVALID_HANDLE_VALUE) break;
		len = GetFileSize(hFile, NULL);
		if (len == 0xFFFFFFFF) break;
		buf = (char *)malloc(len);
		if (buf == NULL) break;
		if (!ReadFile(hFile, buf, len, lpdwSize, NULL)) break;
		if (len != *lpdwSize) break;
		ret = buf;
		buf = NULL;
	} while (0);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	if (buf != NULL) free(buf);
	return ret;
}
#define freefile(p) { if (p != NULL) free(p); }

int GetDwordBE(char *p)
{
	int ret;
	ret  = ((int)(unsigned char)p[0]) << 0x18;
	ret |= ((int)(unsigned char)p[1]) << 0x10;
	ret |= ((int)(unsigned char)p[2]) << 0x08;
	ret |= ((int)(unsigned char)p[3]) << 0x00;
	return ret;
}

int GetWordBE(char *p)
{
	int ret;
	ret  = ((int)(unsigned char)p[0]) << 0x08;
	ret |= ((int)(unsigned char)p[1]) << 0x00;
	return ret;
}

int IsLzxEncoded(char *p)
{
	if (GetDwordBE(p + 4) != 0x4c5a5820) return 0;
	return GetDwordBE(p + 0x12);
}

int GetDwordLE(char *p)
{
	int ret;
	ret  = ((int)(unsigned char)p[3]) << 0x18;
	ret |= ((int)(unsigned char)p[2]) << 0x10;
	ret |= ((int)(unsigned char)p[1]) << 0x08;
	ret |= ((int)(unsigned char)p[0]) << 0x00;
	return ret;
}

int MatchExt(char *ext, char *exts)
{
	char *p;
	char buf[MAX_EXT];
	while (*exts != '\0')
	{
		p = buf;
		while (*exts != ';' && *exts != '\0')
		{
			*p++ = *exts++;
		}
		*p = '\0';
		if (*exts == ';') exts++;
		if (lstrcmpi(ext, buf) == 0) return 1;
	}
	return 0;
}

void GetPathNoExt(char *des, char *src)
{
	char *p = NULL;
	while (*src != '\0')
	{
		if (IsDBCSLeadByte(*src))
		{
			*(des++) = *(src++);
			*(des++) = *(src++);
			continue;
		}
		switch (*src)
		{
			case ':': case '\\': case '/':
				p = NULL;
				break;
			case '.':
				p = des;
				break;
		}
		*(des++) = *(src++);
	}
	if (p != NULL)
		*p = '\0';
	else
		*des = '\0';
}

void GetPathExt(char *des, char *src)
{
	char *p = NULL;
	while (*src != '\0')
	{
		if (IsDBCSLeadByte(*src))
		{
			src += 2;
			continue;
		}
		switch (*src)
		{
			case ':': case '\\': case '/':
				p = NULL;
				break;
			case '.':
				p = src;
				break;
		}
		src++;
	}
	if (p != NULL)
		lstrcpy(des, p + 1);
	else
		*des = '\0';
}

